struct ta_Animdata
(
	name,
	fps,
	offset,
	unk,
	data = #()
)
struct ta_MeshData
(
	name,
	facecount,
	numchilds,
	parent,
	vertexcount,
	id,
	pos,
	rot
)
struct ta_Blockdata
(
	meshcount,
	offset,
	u1,
	u2
)

lebug_scale = 10
fname = getOpenFileName \
caption:"Open Model file" \
types:"SST:TA model (*.pdo)|*.pdo" \
historyCategory:"PMSH_SSTA"
f = fopen fname "rb"
--f = fopen "c:\\Program Files (x86)\\Microprose\\Starship Troopers\\stta\\export\\pows\\bridge.pdo" "rb"


clearlistener()
filesize = readlong f
fn readschars f num = (
	local beginstring = ftell f
	local hstring = readstring f
	fseek f (num-((ftell f)-beginstring)) #seek_cur
	hstring
)
str = readschars f 20
numanimblocks = readlong f
blockcount = readlong f
numunium = readlong f
f1 = readfloat f
l5 = readlong f
l6 = readlong f
l7 = readlong f
f2 = readfloat f --bbox widht
f3 = readfloat f
f4 = readfloat f
f5 = readfloat f
/*print f1
print l5
print l6
print l7
print f2
print f3
print f4
print f5*/


Anim_data= #()
for k = 1 to numanimblocks do (
	local anm = ta_Animdata()
	anm.name = readschars f 20
	local id = readlong f
	anm.fps = readlong f --??
	anm.unk = readlong f	--another offset???
	anm.offset = readlong f
	--anm.cur = ftell f
	anim_data[id+1] = anm
)
for c in Anim_data do (
fseek f c.offset #seek_set
for k = 1 to numunium do (
	local anm  = #()
		local count = readlong f
		local offset = readlong f
		local savepos = ftell f
		fseek f offset #seek_set
		for l = 1 to count do (
			/*print (readbyte f #unsigned)
			print (readbyte f#unsigned)
			print (readbyte f#unsigned)
			print (readbyte f#unsigned)*/
			append anm (readshort f )
			append anm (readshort f )
		)
		--print ("count: "+count as string)
		if k != numunium then (
			fseek f savepos #seek_set	
		)
		append c.data anm
)	
)
Block_data= #()
Bone_data = #()
pd_bones = false
for b = 1 to  blockcount do (
	local blok = ta_Blockdata()
		blok.meshcount = readlong f
		blok.u1 = readlong f
		blok.u2 = readlong f
		blok.offset = readlong f
	append Block_data blok
)
for bl in block_data do(	
local Mesh_data= #()
for k = 1 to bl.meshcount do (
	local msh = ta_MeshData()
	msh.numchilds = readlong f
	msh.id = readlong f +1
	readlong f
	msh.name = readschars f 36
	msh.parent = readlong f+1
	msh.vertexcount = readlong f
	msh.facecount = readlong f
	fseek f 8 #seek_cur	
	r11 = readfloat f
	r12 = readfloat f
	r13 = readfloat f
	
	r14 = readfloat f
	r21 = readfloat f
	r22 = readfloat f
	r23 = readfloat f
	
	r24 = readfloat f
	r31 = readfloat f
	r32 = readfloat f
	r41 = readfloat f
	r42 = readfloat f
	r43 = readfloat f
	r5 = readfloat f
	
	msh.rot = (quat r14 r21 r22 r23 )	
	
	if msh.parent !=0 then (
		msh.pos = ([r11,r12,r13]*lebug_scale)+Mesh_data[msh.parent].pos
	)
	else msh.pos = ([r11,r12,r13]*lebug_scale)
	
	
	if pd_bones == false then (
		local mbone = undefined
		local mat = msh.rot as matrix3
		mat.row4 = msh.pos
		if msh.parent !=0 then (
			
			mbone = BoneSys.createBone  mat.row4  (mat.row4+[0,0,10]) mat.row4
			mbone.name = msh.name
			mbone.transform = mat
			mbone.parent = bone_data[msh.parent]
			mbone.width = lebug_scale/4
			mbone.height = mbone.width
		)
		else (
			mbone = BoneSys.createBone msh.pos msh.pos msh.pos 
			mbone.transform = mat
			mbone.name = msh.name
			mbone.width = lebug_scale/4
			mbone.height = mbone.width
		)
		bone_data[msh.id]= mbone
	)
	Mesh_data[msh.id]= msh
)

pd_bones = true
local vtx  = #()	
--local vtn  = #()	
local uv  = #()
local face = #()		
local foff = 0
local vdata = #()
local bdata = #()
for m in Mesh_data where m.vertexcount != 0 do (
	append vdata m.vertexcount
	append bdata m.id
	for vt = 1 to m.vertexcount do (
		append vtx(([readfloat f,readfloat f,readfloat f] *lebug_scale)+m.pos)	
		local r1 = readfloat f
		local r2 = readfloat f
		local r3 = readfloat f
		
		local r4 = readfloat f
		local r5 = readfloat f
		local r6 = readfloat f
		
		--append vtn([r2,r3,r1] )
		
		append uv([r5,1-r6,r4] )	
	)	
	local maxface =0
	for vt = 1 to m.facecount do (
		fseek f 20 #seek_cur
		fa=readlong f +1
		fb=readlong f +1
		fc=readlong f +1
		if maxface < (amax fa fb fc) then maxface = (amax fa fb fc)
		append face([fa,fb,fc]+foff)
		fseek f 4 #seek_cur		
	)
	foff += maxface
)

	msh = mesh vertices:vtx faces:face  --name: m.name 
	msh.numTVerts = uv.count
	buildTVFaces msh
	for j = 1 to uv.count do setTVert msh j uv[j]
	for j = 1 to face.count do setTVFace msh j face[j]
	--for j = 1 to vtn.count do setNormal msh j vtn[j]
	--msh.transform = m.pos
	--msh.pos = m.pos
	--msh.rotation = m.rot
	max modify mode
	select msh
	local addskin = skin ()
	addModifier msh addskin
	for bn  in bone_data do (
		skinOps.addBone addskin bn 1
	)
	modPanel.setCurrentObject addskin
	local nboneid = 1
	local nextvt = vdata[1]
	for vt = 1 to msh.numverts  do (
		skinOps.ReplaceVertexWeights addskin vt bdata[nboneid] 1
		if vt == nextvt and vt < msh.numverts then (
			nboneid += 1
			nextvt += vdata[nboneid]
		)
		
	)
)

print (ftell f)
fclose f





